#include <stdio.h>
#include <stdlib.h>

// решето Эратосфена 
// http://ru.wikipedia.org/wiki/%D0%E5%F8%E5%F2%EE_%DD%F0%E0%F2%EE%F1%F4%E5%ED%E0

typedef long long data_t;

void eratos(char *arr, ulong size) {
   ulong i, j;
   for(i = 2; i < size; i++)              // цикл по всему массиву от первого простого числа "2"
      if(1 == arr[i]) 
         for(j = i + i; j < size; j += i) // вычеркивание всех чисел кратных i 
           arr[j] = 0;
}

int main(int argc, char **argv) {
   long n;
   char debug = 0;
   if(argc != 2)
      printf("usage: %s [-]<number>\n", argv[0]), exit(1);
   n = atol(argv[1]);                     // максимальное число
   if(n < 0) n = -n, debug = 1;
   ulong k, j;
   char *a = calloc(n + 1, sizeof(char));
   a[0] = a[1] = 0;                       // вычёркиваем "0" и "1"
   for(k = 2; k < n; k++) a[k] = 1;       // остальные размечаем как простые
   eratos(a, n);
   for(k = 0, j = 0; k < n; k++)
      j += (a[k] != 0 ? 1 : 0);
   printf("простых чисел %lu\n", j);
   if(debug) {
#define INLINE 10
      for(k = 0, j = 0; k < n; k++)
         if(1 == a[k]) {
            j++;
            printf("%lu%s", k, (0 == j % INLINE ? "\n" : "\t"));
         }
      if(j % INLINE != 0) printf("\n");
   } 
   free(a);
   return 0;
}
