#include <stdio.h>
#include <stdlib.h>

//     ============>  
//    -|-    |     |
//   --|--   |     |
//  ---|---  |     |
//     1     2     3 

char debug = 0;
ulong nopr = 0;

void put(int from, int to) {
   ++nopr;
   if(!debug) return;
   printf("%d => %d,   ", from, to);
   if(0 == (nopr % 5)) printf("\n"); 
}

int temp(int from, int to) {       // промежуточная позиция
   int i = 1;
   for(; i <= 3; i++)
      if(i != from && i != to)
         return i;
   return 0;                       // ошибка
}

void move(int from, int to, int n) {
   if(n > 1) move(from, temp(from, to), n - 1);
   put(from, to);                  // единичное перемещение 
   if(n > 1) move(temp(from, to), to, n - 1);
}

int main(int argc, char **argv, char **envp) {
   if(argc != 2)
      printf("usage: %s [-]<number>\n", argv[ 0 ]), exit(1);
   int size = atoi(argv[1]);       // число переносимых фишек
   if(size < 0) size = -size, debug = 1;
   if(debug) printf("размер пирамиды: n=%d\n", size); 
   move(1, 3, size);               // вот и всё решение!
   if(debug && (nopr % 5) != 0) printf("\n"); 
   printf("число перемещений %ld\n", nopr); 
   return 0;
}
