#include <stdio.h>
#include <stdlib.h>
#include <math.h>

// метод Ньютона - sqrt( x ) : 
// итерации: z = z - ( z^2 - x ) / ( 2 * z )

long double eps = 1e-9;
int itr = 0;

long double Sqrt(long double arg) {
   long double z = 1.;
   while(1) {
      long double z1 = z - (z * z - arg) / 2. / z;
      if(fabsl(z1 - z) / z < eps) return z;
      z = z1; 
      itr++;
   }
} 

int main(int argc, char **argv) {
   long double sqr = Sqrt(atof(argv[1]));
   printf("[%d]: %.16Lf\n", itr, sqr);
   return 0;
}
