package main

import (
	"fmt"
	"math"
	"os"
	"strconv"
)

const eps = 1e-9

func sqrt(x float64) (float64, int) {
	z := float64(1)
	var i int = 0
	for {
		z1 := z - (z*z-x)/2/z
		if math.Abs(z1-z)/z < eps {
			return z, i
		}
		z = z1
		i++
	}
}

func main() {
	v, _ := strconv.ParseFloat(os.Args[1], 64)
	var n int
	v, n = sqrt(v)
	fmt.Printf("[%v]: %v\n", n, v)
}
