package main

type arr [7]int // тип массива

func atrans(v arr) arr { // для массива
	for i, x := range v {
		v[i] = x + 1
	}
	return v
}

func ptrans(p *arr) { // для указателя массива
	for i, x := range *p {
		(*p)[i] = x + 1
	}
}

func strans(v []int) []int { // для среза
	for i, x := range v {
		v[i] = x + 1
	}
	return v
}

func main() {
	show := func(p arr) { // для массива
		print("[ ", len(p), " ]: ")
		for _, y := range p {
			print(y, " ")
		}
		print("\n")
	}
	shows := func(p []int) { // для среза
		print("[ ", len(p), " ]: ")
		for _, x := range p {
			print(x, " ")
		}
		print("\n")
	}
	a1 := arr{0: 1, 2: 2, 4: 3, 6: 4}
	show(a1)
	a2 := *new(arr)
	a2 = a1 // присвоение массива
	show(a2)
	b1 := atrans(a1) // возврат массива значением
	show(a1)         // массив передаётся по значению!
	show(b1)
	ptrans(&a1) // передача массива адресом!
	show(a1)
	a3 := a2[0:len(a2)] // срез образованный из массива
	shows(a3)
	strans(a3) // срез передаётся по адресу
	shows(a3)
}
