package main

import (
	"fmt"
)

func SliceIndex(limit int, predicate func(i int) bool) int {
	for i := 0; i < limit; i++ {
		if predicate(i) {
			return i
		}
	}
	return -1
}

func main() {
	xs := []int{2, 4, 6, 8, 10}
	ys := []string{"f", "fd", "в", "вы", "выб", "выбор"}
	fmt.Println(
		SliceIndex(len(xs), func(i int) bool { return xs[i] == 7 }),
		SliceIndex(len(xs), func(i int) bool { return xs[i] == 8 }),
		SliceIndex(len(ys), func(i int) bool { return ys[i] == "z" }),
		SliceIndex(len(ys), func(i int) bool { return ys[i] == "выб" }))
}
