// C
#include <stdio.h>
#include <stdlib.h>
#include <limits.h>

int accumulate( int in ) {
   static int total;
   if( in == INT_MIN ) total = 0; 
   else total += in;
   return total;
} 

void my_transform( size_t n_elts, int* in, int* out, int (*op)( int ) ) {
   size_t i;
   for( i = 0; i < n_elts; i++ )
      out[ i ] = op( in[ i ] );
}

int main( void ) {
   int data[ 7 ] = { 8, 6, 7, 5, 3, 0, 9 }, i;
   const int len = sizeof( data ) / sizeof( data[ 0 ] );
   int* result = (int*)calloc( len, sizeof( int ) );
   accumulate( INT_MIN );
   my_transform( len, data, result, accumulate );
   printf( "Result is [ " );
   for( i = 0; i < len; i++ )
      printf( "%d%s", result[ i ], ( i == len - 1 ? " ]\n" : " " ) );
   free( result );
   return 0;
}
