// C++
#include <iostream>
#include <cstddef>

template <class UnaryOperator>
   void my_transform( size_t n_elts, int* in, int* out, UnaryOperator op ) {
   for( size_t i = 0; i < n_elts; i++ )
      out[ i ] = op( in[ i ] );
}

class MyFunctor {
public:
   int total;
   int operator()( int v ) {
      return total += v;
   }
   MyFunctor() : total( 0 ) {}
};

int main( void ) {
  int data[ 7 ] = { 8, 6, 7, 5, 3, 0, 9 };
  const int len = sizeof( data ) / sizeof( data[ 0 ] );
  int result[ len ];
  MyFunctor accumulate;
  my_transform( len, data, result, accumulate );
  std::cout << "Result is [ ";
  for( size_t i = 0; i < len; i++ )
    std::cout << result[ i ] << ( i == len - 1 ? " ]\n" : " " );
  return 0;
}
