// C++11
#include <iostream>
#include <cstddef>
#include <functional>

void my_transform( size_t n_elts, int* in, int* out,
                   std::function<int(int)> op ) {
   for( size_t i = 0; i < n_elts; i++ )
      out[ i ] = op( in[ i ] );
}

int main( void ) {
   int data[ 7 ] = { 8, 6, 7, 5, 3, 0, 9 };
   const int len = sizeof( data ) / sizeof( data[ 0 ] );
   int result[ len ];
   int total = 0;
   my_transform( len, data, result,
                 [&total]( int v ) {
                    return total += v;
                 } );
   std::cout << "Result is [ ";
   for( size_t i = 0; i < len; i++ )
      std::cout << result[ i ] << ( i == len - 1 ? " ]\n" : " " );
  return 0;
}

