// C : GCC
#include <stdio.h>
#include <stdlib.h>

void my_transform( size_t n_elts, int* in, int* out ) {
   int total = 0;
   size_t i;
   int accumulate( int in ) { 
      return total += in;
   }
   for( i = 0; i < n_elts; i++ )
      out[ i ] = accumulate( in[ i ] );
} 

int main( void ) {
   int data[ 7 ] = { 8, 6, 7, 5, 3, 0, 9 }, i;
   const int len = sizeof( data ) / sizeof( data[ 0 ] );
   int* result = (int*)calloc( len, sizeof( int ) );
   my_transform( len, data, result );
   printf( "Result is [ " );
   for( i = 0; i < len; i++ )
      printf( "%d%s", result[ i ], ( i == len - 1 ? " ]\n" : " " ) );
   free( result );
   return 0;
}
