package main
import ("fmt"; "math"; "os"; "runtime"; "sync"; "strconv"; "time")

// π^2/6 = 1/1^2 + 1/2^2 + 1/3^2 + 1/4^2 + ...
func main() {
	ε := 1e-4
	if len(os.Args) > 1 {
		if b, err := strconv.Atoi(os.Args[1]); err == nil {
			runtime.GOMAXPROCS(b + 1)
		} else {
			println("ошибка в параметрах")
			return
		}
	}
	if len(os.Args) > 2 {
		if e, err := strconv.ParseFloat(os.Args[2], 64); err == nil {
			ε = e
		} else {
			println("ошибка в параметрах")
			return
		}
	}
	var fi, mu sync.Mutex
	bazel, n, yet := 0.0, 1, true
	fi.Lock()
	t := time.Now()
	for yet {
		go func(x float64) {
			delta := 1. / (x * x)
			mu.Lock()
			bazel += delta
			if delta < ε {
				if yet { fi.Unlock() }
				yet = false
			}
			mu.Unlock()
		}(float64(n))
		n++
	}
	fi.Lock()
	const result = math.Pi * math.Pi / 6
	fmt.Printf("[%.2e:%d:%d] %f -> %f (%e) [%v]\n", 
	           ε, runtime.GOMAXPROCS(-1) - 1, int(n - 1),
	           bazel, result, bazel - result, time.Since(t))
	return
}
