package main
import ("fmt"; "math"; "os"; "strconv"; "time")

// π^2/6 = 1/1^2 + 1/2^2 + 1/3^2 + 1/4^2 + ...
func main() {
	ε := 1e-17
	if len(os.Args) > 1 {
		if e, err := strconv.ParseFloat(os.Args[1], 64); err == nil {
			ε = e
		} else {
			println("ошибка в параметрах")
			return
		}
	}
	bazel, arg := 0.0, 1.0
	t := time.Now()
	for {
		delta := 1 / (arg * arg)
		if delta < ε { break }
		arg += 1
		bazel += delta
	}
	const result = math.Pi * math.Pi / 6
	fmt.Printf("[%.2e:%d] %f -> %f (%e) [%v]\n", 
	           ε, int(arg),
	           bazel, result, bazel - result, time.Since(t))
}
