#include <iostream>       // std::cout
#include <string>         // std::string
#include <sstream>        // std::ostringstream
#include <thread>         // std::thread
#include <vector>         // std::vector
#include <unistd.h>
using namespace std;

void run(string p) {
   ostringstream msg;
   auto tid = this_thread::get_id();
   msg << tid << " стартовал: " << p << endl;
   cout << msg.str();
   sleep(1);
   msg << tid << " завершился" << endl;
   cout << msg.str();
}

void fun1() {
   string t = __FUNCTION__;
   run(t);
}

void fun2(int x) {
   ostringstream msg;
   msg << __FUNCTION__ << " : " << x;
   run(msg.str());
}

void fun3(int x, float y, string z) {
   ostringstream msg; 
   msg << __FUNCTION__ << " : " << x << " | " << y << " | " << z ;
   run(msg.str()); 
}

class object_task{
public:
   void operator()() const {
      string t = __FUNCTION__;
      run(t);
   }
};

int main( int argc, char *argv[] ) {
   int numpar = (argc > 1 && atoi(argv[1]) > 0) ?
                atoi(argv[1]) : 1;
   vector<thread> vthr;
   for(int i = 0; i < numpar; i++) {
      switch(i%4) {
         case 0: vthr.push_back(thread(fun1));
            break;
         case 1: vthr.push_back(thread(fun2, 123));
            break;
         case 2: vthr.push_back(thread(fun3, 321, 0.123, string("строка")));
            break;
         case 3: vthr.push_back(thread(object_task()));
            break;
      }
      cout << "запустил: " << vthr[i].get_id() << endl;
   }
   for(auto &v : vthr) v.join();
   exit(EXIT_SUCCESS);        // синхронизация ожиданием
}
