#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <sys/wait.h>
#include <sys/time.h>

/* struct timeval {
      time_t      tv_sec;     // seconds 
      suseconds_t tv_usec;    // microseconds 
   };
*/

int main(int argc, char *argv[]) {
   ulong n = argc > 1 ? atol(argv[1]) : 1000;
   pid_t pid[n];
   struct timeval t0, t1;
   gettimeofday(&t0, NULL);
   for(int i = 0; i < n; i++)
      if((pid[i] = fork()) !=0)
         continue;
      else
         return 0;
   for(int i = 0; i < n; i++)
      waitpid(pid[i], NULL, 0);
   gettimeofday(&t1, NULL);
   double t = (t1.tv_usec - t0.tv_usec) + (t1.tv_sec - t0.tv_sec) * 1000000;
   if(t < 1000)
      printf("время выполнения: %.3fµs\n", t);
   else
      printf("[%ld] время выполнения: %.3fms\n", n, t / 1000.);
   return 0;
}
