package main

import (
	"fmt"
	"os"
	"runtime"
	"strconv"
	"sync"
	"sync/atomic"
	"time"
)

var count uint64 = 0
var wg sync.WaitGroup

func main() {
	повторы, потоки := 10000000, 1
	if len(os.Args) > 1 {
		потоки, _ = strconv.Atoi(os.Args[1])
		if потоки > 1 {
			runtime.GOMAXPROCS(потоки)
		}
	}
	if len(os.Args) > 2 {
		повторы, _ = strconv.Atoi(os.Args[2])
	}
	fmt.Printf("число процессоров в системе: %v\n", runtime.NumCPU())
	fmt.Printf("число потоков исполнения: %v\n", runtime.GOMAXPROCS(-1))
	повторы = повторы / потоки
	fmt.Printf("циклов на поток: %v\n", повторы)
	t0 := time.Now()
	for i := 0; i < потоки; i++ {
		wg.Add(1)
		go func() {
			defer wg.Done()
			for i := 0; i < повторы; i++ {
				atomic.AddUint64(&count, 1)
			}
		}()
	}
	wg.Wait()
	fmt.Printf("выполнено циклов: %v\n", count)
	t1 := time.Now()
	fmt.Printf("время выполнения: %v\n", t1.Sub(t0))
}
