package main

import "fmt"

type Item struct {
	id       string  // агрегирование
	price    float64 // агрегирование
	quantity int     // агрегирование
}

func (item *Item) Cost() float64 {
	return item.price * float64(item.quantity)
}

type SpecialItem struct {
	Item          // анонимное поле - встраивание
	catalogId int // именованное поле - агрегирование
}

type LuxuryItem struct {
	Item           // анонимное поле - встраивание
	markup float64 // именованное поле - агрегирование
}

func (item *LuxuryItem) Cost() float64 { // переопределение в производном типе
	return item.Item.Cost() * item.markup
}

func main() {
	special := SpecialItem{Item{"Green", 3, 5}, 207}
	fmt.Println(special, " => ", special.Cost())
	luxury := LuxuryItem{Item{"Green", 3, 5}, 2}
	fmt.Println(luxury, " => ", luxury.Cost())
}
