package main
import "fmt"

type Multiply func(...int) string

func (f Multiply) Apply(i int) Multiply { 
    return func(values ...int) string {
        values = append([]int{i}, values...)
        return f(values...)
    }
}

func main() {
    var multiply Multiply = func(values ...int) string {
        var total int = 1
        for _, value := range values {
            total *= value
        }
        return fmt.Sprintf("%v => %d", values, total)
    }

    fmt.Println("multiply:", multiply(3, 4), "(expect 12)")
    var times2 Multiply = multiply.Apply(2)
    fmt.Println("times 2:", times2(3, 4), "(expect 24)")
    // ... и можно даже каскадно применять к производным от Multiply объектам
    times6 := times2.Apply(3)
    fmt.Println("times 6:", times6(2, 3, 5, 10), "(expect 1800)")
}
